package com.example.pibd22_kalyshev_y_v_motorboat_hard;

import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;

public class DrawningSpeedboat extends DrawningBoat {
    public DrawningSpeedboat(int speed, float weight, Color bodyColor, Color dopColor, boolean bodyKit, boolean wing, boolean sportLine) {
        super(speed, weight, bodyColor, 195, 80);
        SetBoat(new EntitySpeedboat(speed, weight, bodyColor, dopColor, bodyKit, wing, sportLine));
    }
    @Override
    public void DrawTransport(GraphicsContext gc) {
        if (!(GetBoat() instanceof EntitySpeedboat speedboat)) {
            return;
        }

        gc.setStroke(Color.BLACK);
        gc.setLineWidth(2);

        _startPosX += 25;
        _startPosY -= 30;
        super.DrawTransport(gc);
        _startPosX -= 25;
        _startPosY += 30;

        if (speedboat.GetWing()) {
            gc.setFill(speedboat.GetDopColor());
            gc.fillRect(_startPosX, _startPosY, 20, 80);
            gc.strokeRect(_startPosX, _startPosY, 20, 80);
            gc.setFill(speedboat.GetBodyColor());
            gc.fillRect(_startPosX + 20, _startPosY + 20, 10, 40);
            gc.strokeRect(_startPosX + 20, _startPosY + 20, 10, 40);
        }
        _startPosX += 25;
        _startPosY += 10;
        if (speedboat.GetBodyKit()) {
            double[] bodyKitX = {
                    _startPosX + 120,
                    _startPosX + 155,
                    _startPosX + 120,
                    _startPosX + 120,
                    _startPosX + 145,
                    _startPosX + 120
            };
            double[] bodyKitY = {
                    _startPosY + 10,
                    _startPosY + 30,
                    _startPosY + 50,
                    _startPosY + 45,
                    _startPosY + 30,
                    _startPosY + 15
            };
            gc.setFill(speedboat.GetDopColor());
            gc.fillPolygon(bodyKitX, bodyKitY, 6);
        }
        if (speedboat.GetSportLine()) {
            double[] sportLineX = {
                    _startPosX + 70,
                    _startPosX + 80,
                    _startPosX + 120,
                    _startPosX + 110
            };
            double[] sportLineY = {
                    _startPosY,
                    _startPosY,
                    _startPosY + 60,
                    _startPosY + 60
            };
            gc.setFill(speedboat.GetDopColor());
            gc.fillPolygon(sportLineX, sportLineY, 4);
            gc.setFill(Color.BROWN);
            gc.fillOval(_startPosX + 10, _startPosY + 10, 110, 40);
        }
        _startPosX -= 25;
        _startPosY -= 10;
    }
}